/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.92 Revision 1.136
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.92 2011/08/13 11:31:03 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.136 2012/09/27 16:35:41 axs Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4|5) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 49if version_is_at_least 4.8; then
22 IUSE="+exceptions" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
23else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 52fi
26 53
27HOMEPAGE="http://qt.nokia.com/" 54DEPEND="virtual/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
29 56 DEPEND+=" dev-lang/perl"
30LICENSE="|| ( LGPL-2.1 GPL-3 )" 57fi
31IUSE+=" debug pch aqua"
32 58
33RDEPEND=" 59RDEPEND="
34 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
35 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
36 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
37 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
38 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
39 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
40 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
41 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
42 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
43 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
44 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
45 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
46 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
47 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
48 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
49 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
50 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
51 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
52 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
53 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
54 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
55 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
56 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
57 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
58 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
59 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
60 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
61 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
62 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
63 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
64" 96"
65 97
66S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
67 99
68# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 101# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 105
74 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
75 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
76 if has_version '>'${CATEGORY}/${P}-r9999 ; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
77 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
78 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
80 die "aborting to save your system" 112 die "aborting to save your system"
81 else 113 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 115 fi
84 fi
85
86 if [[ "${PN}" == "qt-webkit" ]]; then
87 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
93 ewarn "For more info check out bug #307861"
94 echo
95 fi
96 eshopts_pop
97 fi 116 fi
98 117
99 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
100 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
101 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
106 # avoid extract failure. 125 # avoid extract failure.
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 129 fi
111
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!"
122 fi
123} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
124 137
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
126# @DESCRIPTION: 140# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt
133# tarball
134 143
135# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 145# @DESCRIPTION:
137# Unpacks the sources 146# Unpacks the sources.
138qt4-build_src_unpack() { 147qt4-build_src_unpack() {
139 setqtenv 148 setqtenv
140 local unpack_p="${MY_P}" 149
141 case "${PV}" in 150 if ! version_is_at_least 4.1 $(gcc-version); then
142 4.8.0_beta*) 151 ewarn "Using a GCC version lower than 4.1 is not supported."
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
144 ;; 170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
177 targets+="${MY_P}/${target} "
178 done
179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
182 eend $? || die "failed to unpack"
183 ;;
145 esac 184 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
149 ${QT4_EXTRACT_DIRECTORIES}; do
150 targets+=" ${unpack_p}/${target}"
151 done
152
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
155 case "${PV}" in
156 4.8.0_beta*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 185}
162 186
163# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
164# @DESCRIPTION: 189# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
167# example: 192# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
169# ${FILESDIR}"/mypatch2.patch"
170# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
171 199
172# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 201# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 204qt4-build_src_prepare() {
177 setqtenv 205 setqtenv
178 cd "${S}" 206
179 207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
180 # fix qt 4.7 regression that skips -fvisibility=hidden 208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
181 if version_is_at_least "4.7.0_beta1"; then 211 if version_is_at_least 4.7; then
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 212 # avoid X11 dependency in non-gui packages
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi
186 # fix libx11 dependency on non X packages
187 if version_is_at_least "4.7.0_beta2"; then
188 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
189 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
190 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
191 fi 215 fi
192 216
193 if use aqua; then 217 if use aqua; then
194 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
195 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
196 220
197 sed -e '/^CONFIG/s:app_bundle::' \ 221 sed -e '/^CONFIG/s:app_bundle::' \
198 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
199 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
200 fi 224 fi
201 225
202 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
203 skip_qmake_build_patch 227 skip_qmake_build
204 skip_project_generation_patch 228 skip_project_generation
205 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
206 fi 230 fi
207 231
208 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
209 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
210 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
211 fi 236 fi
212 237
213 # Bug 178652 238 # Bug 178652
214 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
215 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
216 append-flags -fno-gcse 241 append-flags -fno-gcse
217 fi 242 fi
218 243
244 if use_if_iuse c++0x; then
245 append-cxxflags -std=c++0x
246 fi
247
219 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
220 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
221 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
222 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
223 # Bug 253127 252 # Bug 253127
224 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
225 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
226 fi 255 fi
227 256
228 # Bug 261632 257 # Bug 261632
229 if use ppc64; then 258 if use ppc64; then
230 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
231 append-flags -mminimal-toc 260 append-flags -mminimal-toc
232 fi 261 fi
233 262
234 # Bug 282984 && Bug 295530 263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
235 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 264 sed -e "/^SYSTEM_VARIABLES=/i \
236 -i configure || die "sed qmake compilers failed" 265 CC='$(tc-getCC)'\n\
237 # bug 321335 266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n\
270 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
272 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
273 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
274 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
275 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
238 if version_is_at_least 4.6; then 286 if ! version_is_at_least 4.8; then
239 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
240 xargs -0 \ 288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
241 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
242 -i || die "sed test compilers failed"
243 fi 289 fi
244 290
245 # Bug 172219 291 # Bug 172219
246 sed -e "s:X11R6/::" \ 292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
247 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
248 293
249 if [[ ${CHOST} == *-darwin* ]]; then 294 if [[ ${CHOST} == *-darwin* ]]; then
250 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
251 # crippled (by design) :/ 296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
252 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
253 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
254 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
255 -e "s:-arch\s\w*::g" \ 311 -e "s:-arch\s\w*::g" \
256 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
257 314
258 # Fix configure's -arch settings that appear in qmake/Makefile and also 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
259 # fix arch handling (automagically duplicates our -arch arg and breaks 316 # fix arch handling (automagically duplicates our -arch arg and breaks
260 # pch). Additionally disable Xarch support. 317 # pch). Additionally disable Xarch support.
318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
261 sed \ 322 sed \
262 -e "s:-arch i386::" \ 323 -e "s:-arch i386::" \
263 -e "s:-arch ppc::" \ 324 -e "s:-arch ppc::" \
264 -e "s:-arch x86_64::" \ 325 -e "s:-arch x86_64::" \
265 -e "s:-arch ppc64::" \ 326 -e "s:-arch ppc64::" \
266 -e "s:-arch \$i::" \ 327 -e "s:-arch \$i::" \
267 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
268 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
269 -e "s:-Xarch_x86_64::g" \ 330 -e "s:-Xarch_x86_64::g" \
270 -e "s:-Xarch_ppc64::g" \ 331 -e "s:-Xarch_ppc64::g" \
271 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
272 334
273 # On Snow Leopard don't fall back to 10.5 deployment target. 335 # On Snow Leopard don't fall back to 10.5 deployment target.
274 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
275 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
276 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
277 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
278 fi 341 fi
279 fi 342 fi
280 343
281 # this one is needed for all systems with a separate -liconv, apart from 344 # this one is needed for all systems with a separate -liconv, apart from
282 # Darwin, for which the sources already cater for -liconv 345 # Darwin, for which the sources already cater for -liconv
283 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
284 sed \ 347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
285 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
286 -i config.tests/unix/iconv/iconv.pro \ 348 -i config.tests/unix/iconv/iconv.pro \
287 || die "sed on iconv.pro failed" 349 || die "sed iconv.pro failed"
288 fi 350 fi
289 351
290 # we need some patches for Solaris 352 # we need some patches for Solaris
291 sed -i \
292 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
293 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
294 # use GCC over SunStudio 355 # use GCC over SunStudio
295 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
296 # don't flirt with non-Prefix stuff, we're quite possessive 357 # do not flirt with non-Prefix stuff, we're quite possessive
297 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
298 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
299 # strip predefined CFLAGS from qmake ( bug #312689 )
300 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
301 360
302 base_src_prepare 361 # apply patches
362 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
363 epatch_user
303} 364}
304 365
305# @FUNCTION: qt4-build_src_configure 366# @FUNCTION: qt4-build_src_configure
306# @DESCRIPTION: 367# @DESCRIPTION:
307# Default configure phase 368# Default configure phase
308qt4-build_src_configure() { 369qt4-build_src_configure() {
309 setqtenv 370 setqtenv
310 myconf="$(standard_configure_options) ${myconf}" 371
372 local conf="
373 -prefix ${QTPREFIXDIR}
374 -bindir ${QTBINDIR}
375 -libdir ${QTLIBDIR}
376 -docdir ${QTDOCDIR}
377 -headerdir ${QTHEADERDIR}
378 -plugindir ${QTPLUGINDIR}
379 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
380 -datadir ${QTDATADIR}
381 -translationdir ${QTTRANSDIR}
382 -sysconfdir ${QTSYSCONFDIR}
383 -examplesdir ${QTEXAMPLESDIR}
384 -demosdir ${QTDEMOSDIR}
385 -opensource -confirm-license
386 -shared -fast -largefile -stl -verbose
387 -nomake examples -nomake demos"
388
389 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
390 # $(tc-arch). Therefore we convert it to supported values.
391 case "$(tc-arch)" in
392 amd64|x64-*) conf+=" -arch x86_64" ;;
393 ppc-macos) conf+=" -arch ppc" ;;
394 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
395 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
396 x86-macos) conf+=" -arch x86" ;;
397 x86|x86-*) conf+=" -arch i386" ;;
398 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
399 hppa|sh) conf+=" -arch generic" ;;
400 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
401 esac
402
403 conf+=" -platform $(qt_mkspecs_dir)"
404
405 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
406
407 # debug/release
408 if use debug; then
409 conf+=" -debug"
410 else
411 conf+=" -release"
412 fi
413 conf+=" -no-separate-debug-info"
414
415 # exceptions USE flag
416 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
417
418 # disable rpath on Qt >= 4.8 (bug 380415)
419 # but leave it enabled on prefix (bug 417169)
420 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
421
422 # precompiled headers don't work on hardened, where the flag is masked
423 conf+=" $(qt_use pch)"
424
425 # -reduce-relocations
426 # This flag seems to introduce major breakage to applications,
427 # mostly to be seen as a core dump with the message "QPixmap: Must
428 # construct a QApplication before a QPaintDevice" on Solaris.
429 # -- Daniel Vergien
430 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
311 431
312 # this one is needed for all systems with a separate -liconv, apart from 432 # this one is needed for all systems with a separate -liconv, apart from
313 # Darwin, for which the sources already cater for -liconv 433 # Darwin, for which the sources already cater for -liconv
314 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 434 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
315 myconf+=" -liconv" 435 conf+=" -liconv"
436 fi
316 437
317 if has glib ${IUSE//+} && use glib; then 438 if use_if_iuse glib; then
318 # use -I, -L and -l from configure
319 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 439 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
320 # avoid the -pthread argument 440 # avoid the -pthread argument
321 myconf+=" ${glibflags//-pthread}" 441 conf+=" ${glibflags//-pthread}"
322 unset glibflags 442 unset glibflags
323 fi 443 fi
324 444
445 if use_if_iuse qpa; then
446 echo
447 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
448 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
449 ewarn "disable it before reporting any bugs related to this useflag."
450 echo
451 conf+=" -qpa"
452 fi
453
325 if use aqua ; then 454 if use aqua; then
326 # On (snow) leopard use the new (frameworked) cocoa code. 455 # On (snow) leopard use the new (frameworked) cocoa code.
327 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 456 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
328 myconf+=" -cocoa -framework" 457 conf+=" -cocoa -framework"
458 # We need the source's headers, not the installed ones.
459 conf+=" -I${S}/include"
460 # Add hint for the framework location.
461 conf+=" -F${QTLIBDIR}"
329 462
330 # We are crazy and build cocoa + qt3support :-) 463 # We are crazy and build cocoa + qt3support :-)
331 if use qt3support; then 464 if use qt3support; then
332 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 465 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
333 -i configure 466 -i configure || die
334 fi 467 fi
335 468 else
336 # We need the source's headers, not the installed ones. 469 conf+=" -no-framework"
337 myconf+=" -I${S}/include"
338
339 # Add hint for the framework location.
340 myconf+=" -F${QTLIBDIR}"
341 fi 470 fi
342 else 471 else
343 # freetype2 include dir is non-standard, thus include it on configure 472 # freetype2 include dir is non-standard, thus pass it to configure
344 # use -I from configure
345 myconf+=" $(pkg-config --cflags freetype2)" 473 conf+=" $(pkg-config --cflags-only-I freetype2)"
346 fi 474 fi
347 475
348 # Disable SSE4.x, since auto-detection is currently broken 476 conf+=" ${myconf}"
349 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 477 myconf=
350 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
351 478
352 echo ./configure ${myconf} 479 echo ./configure ${conf}
353 ./configure ${myconf} || die "./configure failed" 480 ./configure ${conf} || die "./configure failed"
354 myconf=""
355 481
356 prepare_directories ${QT4_TARGET_DIRECTORIES} 482 prepare_directories ${QT4_TARGET_DIRECTORIES}
357} 483}
358 484
359# @FUNCTION: qt4-build_src_compile 485# @FUNCTION: qt4-build_src_compile
486# @DESCRIPTION:
360# @DESCRIPTION: Actual compile phase 487# Actual compile phase
361qt4-build_src_compile() { 488qt4-build_src_compile() {
362 setqtenv 489 setqtenv
363 490
364 build_directories ${QT4_TARGET_DIRECTORIES} 491 build_directories ${QT4_TARGET_DIRECTORIES}
365} 492}
366 493
367# @FUNCTION: qt4-build_src_test 494# @FUNCTION: qt4-build_src_test
368# @DESCRIPTION: 495# @DESCRIPTION:
369# Runs tests only in target directories. 496# Runs tests only in target directories.
370qt4-build_src_test() { 497qt4-build_src_test() {
498 # QtMultimedia does not have any test suite (bug #332299)
499 [[ ${PN} == qt-multimedia ]] && return
500
371 for dir in ${QT4_TARGET_DIRECTORIES}; do 501 for dir in ${QT4_TARGET_DIRECTORIES}; do
372 emake -j1 check -C ${dir} 502 emake -j1 check -C ${dir}
373 done 503 done
374} 504}
375 505
376# @FUNCTION: fix_includes 506# @FUNCTION: fix_includes
377# @DESCRIPTION: 507# @DESCRIPTION:
378# For MacOSX we need to add some symlinks when frameworks are 508# For MacOS X we need to add some symlinks when frameworks are
379# being used, to avoid complications with some more or less stupid packages. 509# being used, to avoid complications with some more or less stupid packages.
380fix_includes() { 510fix_includes() {
381 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 511 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
512 local frw dest f h rdir
382 # Some packages tend to include <Qt/...> 513 # Some packages tend to include <Qt/...>
383 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 514 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
384 515
385 # Fake normal headers when frameworks are installed... eases life later on 516 # Fake normal headers when frameworks are installed... eases life later
386 local dest f 517 # on, make sure we use relative links though, as some ebuilds assume
518 # these dirs exist in src_install to add additional files
519 f=${QTHEADERDIR}
520 h=${QTLIBDIR}
521 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
522 f=${f#*/}
523 h=${h#*/}
524 done
525 rdir=${h}
526 f="../"
527 while [[ ${h} == */* ]] ; do
528 f="${f}../"
529 h=${h#*/}
530 done
531 rdir="${f}${rdir}"
532
387 for frw in "${D}${QTLIBDIR}"/*.framework; do 533 for frw in "${D}${QTLIBDIR}"/*.framework; do
388 [[ -e "${frw}"/Headers ]] || continue 534 [[ -e "${frw}"/Headers ]] || continue
389 f=$(basename ${frw}) 535 f=$(basename ${frw})
390 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 536 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
391 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 537 dosym "${rdir}"/${f}/Headers "${dest}"
392 538
393 # Link normal headers as well. 539 # Link normal headers as well.
394 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 540 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
395 h=$(basename ${hdr}) 541 h=$(basename ${hdr})
396 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 542 dosym "../${rdir}"/${f}/Headers/${h} \
543 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
397 done 544 done
398 done 545 done
399 fi 546 fi
400} 547}
401 548
403# @DESCRIPTION: 550# @DESCRIPTION:
404# Perform the actual installation including some library fixes. 551# Perform the actual installation including some library fixes.
405qt4-build_src_install() { 552qt4-build_src_install() {
406 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 553 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
407 setqtenv 554 setqtenv
555
408 install_directories ${QT4_TARGET_DIRECTORIES} 556 install_directories ${QT4_TARGET_DIRECTORIES}
409 install_qconfigs 557 install_qconfigs
410 fix_library_files 558 fix_library_files
411 fix_includes 559 fix_includes
560
412 # remove .la files since we are building only shared Qt libraries 561 # remove .la files since we are building only shared Qt libraries
413 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 562 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
414} 563}
415 564
416# @FUNCTION: setqtenv 565# @FUNCTION: setqtenv
566# @INTERNAL
417setqtenv() { 567setqtenv() {
418 # Set up installation directories 568 # Set up installation directories
419 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
420 QTPREFIXDIR=${EPREFIX}/usr 569 QTPREFIXDIR=${EPREFIX}/usr
421 QTBINDIR=${EPREFIX}/usr/bin 570 QTBINDIR=${EPREFIX}/usr/bin
422 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 571 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
423 QMAKE_LIBDIR_QT=${QTLIBDIR}
424 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 572 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
425 QTDATADIR=${EPREFIX}/usr/share/qt4
426 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 573 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
427 QTHEADERDIR=${EPREFIX}/usr/include/qt4 574 QTHEADERDIR=${EPREFIX}/usr/include/qt4
428 QTPLUGINDIR=${QTLIBDIR}/plugins 575 QTPLUGINDIR=${QTLIBDIR}/plugins
576 QTIMPORTDIR=${QTLIBDIR}/imports
577 QTDATADIR=${EPREFIX}/usr/share/qt4
578 QTTRANSDIR=${QTDATADIR}/translations
429 QTSYSCONFDIR=${EPREFIX}/etc/qt4 579 QTSYSCONFDIR=${EPREFIX}/etc/qt4
430 QTTRANSDIR=${QTDATADIR}/translations
431 QTEXAMPLESDIR=${QTDATADIR}/examples 580 QTEXAMPLESDIR=${QTDATADIR}/examples
432 QTDEMOSDIR=${QTDATADIR}/demos 581 QTDEMOSDIR=${QTDATADIR}/demos
582 QMAKE_LIBDIR_QT=${QTLIBDIR}
433 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 583 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
584
434 PLATFORM=$(qt_mkspecs_dir) 585 PLATFORM=$(qt_mkspecs_dir)
435
436 unset QMAKESPEC 586 unset QMAKESPEC
437}
438 587
439# @FUNCTION: standard_configure_options 588 export XDG_CONFIG_HOME="${T}"
440# @DESCRIPTION:
441# Sets up some standard configure options, like libdir (if necessary), whether
442# debug info is wanted or not.
443standard_configure_options() {
444 local myconf=
445
446 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
447
448 # Disable visibility explicitly if gcc version isn't 4
449 if [[ $(gcc-major-version) -lt 4 ]]; then
450 myconf+=" -no-reduce-exports"
451 fi
452
453 # precompiled headers doesn't work on hardened, where the flag is masked.
454 myconf+=" $(qt_use pch)"
455
456 if use debug; then
457 myconf+=" -debug"
458 else
459 myconf+=" -release"
460 fi
461 myconf+=" -no-separate-debug-info"
462
463 use aqua && myconf+=" -no-framework"
464
465 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
466 # $(tc-arch). Therefore we convert it to supported values.
467 case "$(tc-arch)" in
468 amd64|x64-*) myconf+=" -arch x86_64" ;;
469 ppc-macos) myconf+=" -arch ppc" ;;
470 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
471 sparc|sparc-*) myconf+=" -arch sparc" ;;
472 x86-macos) myconf+=" -arch x86" ;;
473 x86|x86-*) myconf+=" -arch i386" ;;
474 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
475 hppa|sh) myconf+=" -arch generic" ;;
476 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
477 esac
478
479 # 4.5: build everything but qt-xmlpatterns w/o exceptions
480 # 4.6: exceptions USE flag
481 local exceptions="-exceptions"
482 case "${PV}" in
483 4.5.*)
484 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
485 ;;
486 *)
487 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
488 ;;
489 esac
490
491 # note about -reduce-relocations:
492 # That flag seems to introduce major breakage to applications,
493 # mostly to be seen as a core dump with the message "QPixmap: Must
494 # construct a QApplication before a QPaintDevice" on Solaris
495 # -- Daniel Vergien
496 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
497
498 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
499 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
500 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
501 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
502 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
503 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
504 ${exceptions}
505 -nomake examples -nomake demos"
506
507 echo "${myconf}"
508} 589}
509 590
510# @FUNCTION: prepare_directories 591# @FUNCTION: prepare_directories
511# @USAGE: < directories > 592# @USAGE: < directories >
593# @INTERNAL
512# @DESCRIPTION: 594# @DESCRIPTION:
513# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 595# Generates Makefiles for the given list of directories.
514prepare_directories() { 596prepare_directories() {
515 for x in "$@"; do 597 for x in "$@"; do
516 pushd "${S}"/${x} >/dev/null 598 pushd "${S}"/${x} >/dev/null || die
517 einfo "running qmake in: $x" 599 einfo "Running qmake in: ${x}"
518 # avoid running over the maximum argument number, bug #299810 600 # avoid running over the maximum argument number, bug #299810
519 { 601 {
520 echo "${S}"/mkspecs/common/*.conf 602 echo "${S}"/mkspecs/common/*.conf
521 find "${S}" -name '*.pr[io]' 603 find "${S}" -name '*.pr[io]'
522 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 604 } | xargs sed -i \
605 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
606 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
607 || die
523 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 608 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
524 popd >/dev/null 609 popd >/dev/null || die
525 done 610 done
526} 611}
527 612
528 613
529# @FUNCTION: build_directories 614# @FUNCTION: build_directories
530# @USAGE: < directories > 615# @USAGE: < directories >
616# @INTERNAL
531# @DESCRIPTION: 617# @DESCRIPTION:
532# Compiles the code in $QT4_TARGET_DIRECTORIES 618# Compiles the code in the given list of directories.
533build_directories() { 619build_directories() {
534 for x in "$@"; do 620 for x in "$@"; do
535 pushd "${S}"/${x} >/dev/null 621 pushd "${S}"/${x} >/dev/null || die
536 emake CC="$(tc-getCC)" \ 622 emake CC="$(tc-getCC)" \
537 CXX="$(tc-getCXX)" \ 623 CXX="$(tc-getCXX)" \
538 LINK="$(tc-getCXX)" || die "emake failed" 624 LINK="$(tc-getCXX)" || die "emake failed"
539 popd >/dev/null 625 popd >/dev/null || die
540 done 626 done
541} 627}
542 628
543# @FUNCTION: install_directories 629# @FUNCTION: install_directories
544# @USAGE: < directories > 630# @USAGE: < directories >
631# @INTERNAL
545# @DESCRIPTION: 632# @DESCRIPTION:
546# run emake install in the given directories, which are separated by spaces 633# Runs emake install in the given directories, which are separated by spaces.
547install_directories() { 634install_directories() {
548 for x in "$@"; do 635 for x in "$@"; do
549 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 636 pushd "${S}"/${x} >/dev/null || die
550 emake INSTALL_ROOT="${D}" install || die "emake install failed" 637 emake INSTALL_ROOT="${D}" install || die "emake install failed"
551 popd >/dev/null || die "Can't popd from ${S}/${x}" 638 popd >/dev/null || die
552 done 639 done
553} 640}
554 641
555# @ECLASS-VARIABLE: QCONFIG_ADD 642# @ECLASS-VARIABLE: QCONFIG_ADD
556# @DESCRIPTION: 643# @DESCRIPTION:
566# @DESCRIPTION: 653# @DESCRIPTION:
567# List variables that should be defined at the top of QtCore/qconfig.h 654# List variables that should be defined at the top of QtCore/qconfig.h
568: ${QCONFIG_DEFINE:=} 655: ${QCONFIG_DEFINE:=}
569 656
570# @FUNCTION: install_qconfigs 657# @FUNCTION: install_qconfigs
658# @INTERNAL
659# @DESCRIPTION:
571# @DESCRIPTION: Install gentoo-specific mkspecs configurations 660# Install gentoo-specific mkspecs configurations.
572install_qconfigs() { 661install_qconfigs() {
573 local x 662 local x
574 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 663 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
575 for x in QCONFIG_ADD QCONFIG_REMOVE; do 664 for x in QCONFIG_ADD QCONFIG_REMOVE; do
576 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 665 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
587 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 676 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
588 fi 677 fi
589} 678}
590 679
591# @FUNCTION: generate_qconfigs 680# @FUNCTION: generate_qconfigs
592# @DESCRIPTION: Generates gentoo-specific configurations 681# @INTERNAL
682# @DESCRIPTION:
683# Generates gentoo-specific qconfig.{h,pri}.
593generate_qconfigs() { 684generate_qconfigs() {
594 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 685 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
595 local x qconfig_add qconfig_remove qconfig_new 686 local x qconfig_add qconfig_remove qconfig_new
596 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 687 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
597 [[ -f ${x} ]] || continue 688 [[ -f ${x} ]] || continue
598 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 689 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
599 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 690 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
645 fi 736 fi
646 fi 737 fi
647} 738}
648 739
649# @FUNCTION: qt4-build_pkg_postrm 740# @FUNCTION: qt4-build_pkg_postrm
741# @DESCRIPTION:
650# @DESCRIPTION: Generate configurations when the package is completely removed 742# Regenerate configuration when the package is completely removed.
651qt4-build_pkg_postrm() { 743qt4-build_pkg_postrm() {
652 generate_qconfigs 744 generate_qconfigs
653} 745}
654 746
655# @FUNCTION: qt4-build_pkg_postinst 747# @FUNCTION: qt4-build_pkg_postinst
748# @DESCRIPTION:
656# @DESCRIPTION: Generate configuration, plus throws a message about possible 749# Regenerate configuration, plus throw a message about possible
657# breakages and proposed solutions. 750# breakages and proposed solutions.
658qt4-build_pkg_postinst() { 751qt4-build_pkg_postinst() {
659 generate_qconfigs 752 generate_qconfigs
660} 753}
661 754
662# @FUNCTION: skip_qmake_build_patch 755# @FUNCTION: skip_qmake_build
756# @INTERNAL
663# @DESCRIPTION: 757# @DESCRIPTION:
664# Don't need to build qmake, as it's already installed from qt-core 758# Patches configure to skip qmake compilation, as it's already installed by qt-core.
665skip_qmake_build_patch() { 759skip_qmake_build() {
666 # Don't need to build qmake, as it's already installed from qt-core
667 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 760 sed -i -e "s:if true:if false:g" "${S}"/configure || die
668} 761}
669 762
670# @FUNCTION: skip_project_generation_patch 763# @FUNCTION: skip_project_generation
764# @INTERNAL
671# @DESCRIPTION: 765# @DESCRIPTION:
672# Exit the script early by throwing in an exit before all of the .pro files are scanned 766# Exit the script early by throwing in an exit before all of the .pro files are scanned.
673skip_project_generation_patch() { 767skip_project_generation() {
674 # Exit the script early by throwing in an exit before all of the .pro files are scanned
675 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 768 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
676 -i "${S}"/configure || die "Sed failed"
677} 769}
678 770
679# @FUNCTION: symlink_binaries_to_buildtree 771# @FUNCTION: symlink_binaries_to_buildtree
772# @INTERNAL
680# @DESCRIPTION: 773# @DESCRIPTION:
681# Symlink generated binaries to buildtree so they can be used during compilation 774# Symlinks generated binaries to buildtree, so they can be used during compilation time.
682# time
683symlink_binaries_to_buildtree() { 775symlink_binaries_to_buildtree() {
684 for bin in qmake moc uic rcc; do 776 for bin in qmake moc uic rcc; do
685 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 777 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
686 done 778 done
687} 779}
688 780
689# @FUNCTION: fix_library_files 781# @FUNCTION: fix_library_files
782# @INTERNAL
690# @DESCRIPTION: 783# @DESCRIPTION:
691# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 784# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
692# moves the *.pc-files into the pkgconfig directory 785# moves the *.pc files into the pkgconfig directory.
693fix_library_files() { 786fix_library_files() {
787 local libfile
694 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 788 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
695 if [[ -e ${libfile} ]]; then 789 if [[ -e ${libfile} ]]; then
696 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 790 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
697 fi 791 fi
698 done 792 done
699 793
700 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 794 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
701 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 795 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
702 if [[ -e ${libfile} ]]; then 796 if [[ -e ${libfile} ]]; then
703 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 797 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
704 798
705 # Move .pc files into the pkgconfig directory 799 # Move .pc files into the pkgconfig directory
706 dodir ${QTPCDIR#${EPREFIX}} 800 dodir ${QTPCDIR#${EPREFIX}}
707 mv ${libfile} "${D}"/${QTPCDIR}/ \ 801 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
708 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
709 fi 802 fi
710 done 803 done
711 804
712 # Don't install an empty directory 805 # Don't install an empty directory
713 rmdir "${D}"/${QTLIBDIR}/pkgconfig 806 rmdir "${D}"/${QTLIBDIR}/pkgconfig
714} 807}
715 808
716# @FUNCTION: qt_use 809# @FUNCTION: qt_use
717# @USAGE: < flag > [ feature ] [ enableval ] 810# @USAGE: < flag > [ feature ] [ enableval ]
718# @DESCRIPTION: 811# @DESCRIPTION:
719# This will echo "${enableval}-${feature}" if <flag> is enabled, or 812# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
720# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 813# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
721# will be used for that. If [enableval] is not specified, it omits the 814# will be used for that. If [enableval] is not specified, it omits the
722# assignment-part 815# "-${enableval}" part.
723qt_use() { 816qt_use() {
724 local flag=$1 817 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
725 local feature=$1
726 local enableval=
727
728 [[ -n $2 ]] && feature=$2
729 [[ -n $3 ]] && enableval=-$3
730
731 if use ${flag}; then
732 echo "${enableval}-${feature}"
733 else
734 echo "-no-${feature}"
735 fi
736} 818}
737 819
738# @FUNCTION: qt_mkspecs_dir 820# @FUNCTION: qt_mkspecs_dir
739# @RETURN: the specs-directory w/o path 821# @RETURN: the specs-directory w/o path
740# @DESCRIPTION: 822# @DESCRIPTION:
741# Allows us to define which mkspecs dir we want to use. 823# Allows us to define which mkspecs dir we want to use.
742qt_mkspecs_dir() { 824qt_mkspecs_dir() {
743 # Allows us to define which mkspecs dir we want to use.
744 local spec 825 local spec=
745 826
746 case ${CHOST} in 827 case "${CHOST}" in
747 *-freebsd*|*-dragonfly*) 828 *-freebsd*|*-dragonfly*)
748 spec=freebsd ;; 829 spec=freebsd ;;
749 *-openbsd*) 830 *-openbsd*)
750 spec=openbsd ;; 831 spec=openbsd ;;
751 *-netbsd*) 832 *-netbsd*)
762 *-solaris*) 843 *-solaris*)
763 spec=solaris ;; 844 spec=solaris ;;
764 *-linux-*|*-linux) 845 *-linux-*|*-linux)
765 spec=linux ;; 846 spec=linux ;;
766 *) 847 *)
767 die "Unknown CHOST, no platform choosen." 848 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
768 esac 849 esac
769 850
770 CXX=$(tc-getCXX) 851 case "$(tc-getCXX)" in
771 if [[ ${CXX} == *g++* ]]; then 852 *g++*)
772 spec+=-g++ 853 spec+=-g++ ;;
773 elif [[ ${CXX} == *icpc* ]]; then 854 *icpc*)
774 spec+=-icc 855 spec+=-icc ;;
775 else 856 *)
776 die "Unknown compiler ${CXX}." 857 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
777 fi 858 esac
778 if [[ -n ${LIBDIR/lib} ]]; then
779 spec+=-${LIBDIR/lib}
780 fi
781 859
782 # Add -64 for 64bit profiles 860 # Add -64 for 64bit profiles
783 if use x64-freebsd || 861 if use x64-freebsd ||
784 use amd64-linux || 862 use amd64-linux ||
785 use x64-macos || 863 use x64-macos ||
790 fi 868 fi
791 869
792 echo "${spec}" 870 echo "${spec}"
793} 871}
794 872
795# @FUNCTION: qt_assistant_cleanup
796# @RETURN: nothing
797# @DESCRIPTION:
798# Tries to clean up tools.pro for qt-assistant ebuilds
799# Meant to be called in src_prepare
800qt_assistant_cleanup() {
801 # different versions (and branches...) may need different handling,
802 # add a case if you need special handling
803 case "${MY_PV_EXTRA}" in
804 *kde-qt*)
805 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
806 -e "/mac/,/^embedded.*makeqpf$/d" \
807 -i tools/tools.pro || die "patching tools.pro failed"
808 ;;
809 *)
810 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
811 -e "/mac/,/^embedded.*makeqpf$/d" \
812 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
813 -i tools/tools.pro || die "patching tools.pro failed"
814 ;;
815 esac
816}
817
818# @FUNCTION: qt_nolibx11 873# @FUNCTION: qt_nolibx11
819# @RETURN: nothing 874# @INTERNAL
820# @DESCRIPTION: 875# @DESCRIPTION:
821# Ignore X11 tests for packages that don't need X libraries installed 876# Ignore X11 tests for packages that don't need X libraries installed.
822qt_nolibx11() { 877qt_nolibx11() {
823 einfo "removing X11 check to allow X-less compilation"
824 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 878 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
825 die "x11 check sed failed" 879 die "x11 check sed failed"
826} 880}
827 881
828EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 882EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.92  
changed lines
  Added in v.1.136

  ViewVC Help
Powered by ViewVC 1.1.20